' //***************************************************************************
' // ***** Script Header *****
' //
' // File:      QAWebAuto.vbs
' //
' // Additional files required:  Elevate.cmd; elevate.vbs; QAWebManual.vbs
' //
' // Purpose:   Coordinate priorities between driver and QA software 
' //            after system installation (and after reboot)
' //
' // Usage:     (Not used directly. Added to registry Run key by QAWebManual.vbs)
' //
' // Version:   1.0.2
' // Date :     15/Oct/2009
' //
' // History:
' // 1.0.0   15/02/2005   Created initial version.
' // 1.0.1   18/02/2008   Added tweaks for error handling and UAC prompts
' // 1.0.2   15/Oct/2009  Added support for Windows 7
' //
' // ***** End Header *****
' //***************************************************************************

' // Get OS type
strComputer = "."
IsXP = 0
IsVista = 0
IsWindows7 = 0
Set objWMI = GetObject("winmgmts:\\" & strComputer & "\root\CIMV2") 
Set colItems = objWMI.ExecQuery("SELECT * FROM Win32_OperatingSystem",,48) 
For Each objItem in colItems
  strSystem = objItem.SystemDirectory
  if instr(objItem.Caption, "Vista") > 0 then
    IsVista = 1
  else
    if instr(objItem.Caption, "Windows 7") > 0 then
      IsWindows7 = 1
    else
      IsXP = 1
    end if
  end if
Next

Set objShell = CreateObject("Shell.Application")
If WScript.Arguments.Count = 0 and isWindows7 Then
    ObjShell.ShellExecute "wscript.exe", """" & _
    WScript.ScriptFullName & """" & " RunAsAdmin", , "runas", 1
Else
    Set objWshShell = WScript.CreateObject("WScript.Shell")
    Set objWshProcessEnv = objWshShell.Environment("PROCESS")

    'Run the BarcoPnPSetup.exe application
    strApplication = "\BarcoPnPSetup.exe"
    strArguments = "-initialize"

    if IsVista = 1 or IsWindows7 = 1 then
      'For Vista or Windows 7 run with elevated priviliges
      objShell.ShellExecute strSystem & strApplication, strArguments, "", "runas"
    else
      'For other OS's run using regular command
      objShell.ShellExecute strSystem & strApplication, strArguments
    end if

    'Wait for the BarcoPnPSetup.exe to finish
    set svc=getobject("winmgmts:root\cimv2")
    sQuery="select * from win32_process where name='BarcoPnPSetup.exe'"
    set cproc=svc.execquery(sQuery)
    iniproc=cproc.count    'it can be more than 1
    Do While iniproc = 1
      wscript.sleep 5000
      set svc=getobject("winmgmts:root\cimv2")
      sQuery="select * from win32_process where name='BarcoPnPSetup.exe'"
      set cproc=svc.execquery(sQuery)
      iniproc=cproc.count
    Loop
    
    set cproc=nothing
    set svc=nothing

    strSvcName = "QAWebPMS"
    strStartupType = "Automatic"
    strQAWeb = "False"
    const HKEY_LOCAL_MACHINE = &H80000002
    Set oReg=GetObject("winmgmts:{impersonationLevel=impersonate}!\\" &_ 
                       strComputer & "\root\default:StdRegProv")

    'Check if the QAWebPMS Service exists on the Computer
    Set objWMIService = GetObject("winmgmts:" & "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")
    Set colListOfServices = objWMIService.ExecQuery("Select * from Win32_Service Where Name ='" & strSvcName & "'")
    For Each objService in colListOfServices
        'QAWeb Service Exists so set QAWeb flag to True
        strQAWeb = "True"

        'Set the QAWebPMS Service to Automatic
        set objWMI = GetObject("winmgmts:\\" & strComputer & "\root\cimv2")
        set objService = objWMI.Get("Win32_Service.Name='" & strSvcName & "'")
        intRC = objService.Change(,,,,strStartupType)

        'Lets loop if the error was that the services database was locked.  If we fail to successfully switch the service to Automatic after 3 minutes then we will pop up the error box
        intCounter = 0
        Do While intRC = 11
        wscript.sleep 5000
        intRC = objService.Change(,,,,strStartupType)
        intCounter = intCounter + 1
        if intRC = 11 then
            if intCounter > 36 then
                intRC = 2
            end if
        end if
        Loop

        'Check errorlevel
        if intRC > 0 then
            WScript.Echo "Please log in as Administrator to complete the Barco System Installation"
        else
            'Start the QAWebPMS Service
            strService = "'QAWebPMS'"
            Set objWMIService = GetObject("winmgmts:" & "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")
            Set colRunningServices = objWMIService.ExecQuery("Select * from Win32_Service Where Name =" & strService & " ")

            For Each objService1 in colRunningServices 
                If objService1.State = "Running" Then
                Else
                    objService1.StartService
                End If
            Next
        end if
    Next

    'Delete QAWebPMSAuto from the run key
    strKeyPath = "SOFTWARE\Microsoft\Windows\CurrentVersion\Run"
    strStringValueName = "QAWebPMSAuto"
    oReg.DeleteValue HKEY_LOCAL_MACHINE,strKeyPath,strStringValueName

    'Read OS name, if Vista re-enable UAC prompts
    if IsVista = 1 or IsWindows7 then
        'Re-enable UAC prompts (disabled by Master Installer)
        strKeyPath = "SOFTWARE\Microsoft\Windows\CurrentVersion\Policies\System"
        strStringValueName = "BackupUAC"
        
        'Change the UAC value to the original setting
        oReg.GetDWORDValue HKEY_LOCAL_MACHINE,strKeyPath,strStringValueName, strUAC
        oReg.SetDWORDValue HKEY_LOCAL_MACHINE,strKeyPath,"ConsentPromptBehaviorAdmin",strUAC
    End if
End if